//: C08:ConstructorOrder.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Pořadí volání konstruktoru.
#include <iostream>
#include <typeinfo>
using namespace std;

template<int id> class Oznameni {
public:
  Oznameni() {
    cout << typeid(*this).name() << " konstruktor" << endl;
  }
  ~Oznameni() {
    cout << typeid(*this).name() << " destruktor" << endl;
  }
};

class X : public Oznameni<0> {
  Oznameni<1> m1;
  Oznameni<2> m2;
public:
  X() { cout << "X::X()" << endl; }
  ~X() { cout << "X::~X()" << endl; }
};

int main() { X x; } ///:~
